// https://www.ime.usp.br/~igormf/ima-tutorial/

// Nesse arquivo, implementamos as funções relacionadas ao funcionamento do iArithmetic
// voltadas principalmente ao seu funcionamento e regras

var parcelas;
var desenhos;
var desafios;
var operacao;


// Funcao para ilustrar a resposta do aluno (mesmo sem Moodle/iTarefa)
function avaliar () {
  var strC = getAnswer();
  alert(strC);
  }


// Inserir botao no HTML
function criarBotao (idBotao) {
  //var botoes = document.getElementById("botoes");
  var strLinha = '   <button id="' + idBotao + '"  title="Avaliar/submeter" onclick="avaliar();">Avaliar/Submeter</button>';
  return strLinha;
  }


// Recebe os dados que estão armazenados no Moodle
// No caso de o aluno ainda não ter submetido nenhuma resolução, apenas os dados relacionados
// à atividade são carregados. Enquanto que caso haja alguma resposta enviada ao exercício,
// os dados da resposta são recebidos. 
// Note que este funcionamento foi definido no método getAnswer() do arquivo js/integration-functions.js
function organizaAtividade (dadoCru) {
  try {
    // processa: [{"name":"operacao","value":"ADI"}, ... ]
    dados = JSON.parse(dadoCru);
  } catch (e) {
    console.log("organizaAtividade(.): dadoCru=" + dadoCru);
    return "";
    }
  // Se o primeiro campo dos dados não for "name", trata-se apenas da atividade, sem uma resolução enviada previamente:
  if (dados[0].name != null) {
    // Para deixar o código mais organizado, o método "organizaAtividadeSemResolucao" fica responsável por tratar
    // de montar a atividade na tela
    organizaAtividadeSemResolucao(dados);
  } else { // Caso entre nesse "else", os dados recebidos incluem informações sobre uma tentativa do aluno
    // O método apresentaRespostas apresenta a atividade que foi proposta ao aluno e as respostas enviadas
    apresentaRespostas(dados);
    }
  }


// Apresenta a atividade na tela do usuário
function organizaAtividadeSemResolucao (dados) {
  operacao = dados[0].value;
  // Atribuindo valores aleatórios para as parcelas:
  parcelas = Array();
  for (i = 0; i < dados[1].value;) try {
    console.log(i + ": " + dados[1].value);
    var temp = Math.floor((Math.random() * dados[4].value) + dados[3].value);

    // Verificar se o número não é repetido:
    var ja_existe = false;
    for (j = 0; j < i; j++) {
      if (parcelas[j] == temp) { ja_existe = true; }
      }
    // Se não for repetido, adiciona e incrementa o i
    if (ja_existe == false) {
      parcelas.push(temp);
      i ++;
      }
  } catch (e) {
    console.log("organizaAtividadeSemResolucao(.): i=" + i + ", " + dados[1]);
    return "";
    }

  // Escolhendo os desenhos que representarão cada valor:
  desenhos = Array();
  for (i = 0; i < dados[1].value;) {
    var temp = Math.floor((Math.random() * 10) + 1);

    // Verificar se o número não é repetido:
    var ja_existe = false;
    for (j = 0; j < i; j++) {
      if (desenhos[j] == temp) {
        ja_existe = true;
        }
      }
    // Se não for repetido, adiciona e incrementa o i
    if (ja_existe == false) {
      desenhos.push(temp);
      console.log(temp);
      i ++;
      }
    }

  // Gerando os desafios:
  desafios = Array();
  for (i = 0; i < dados[2].value; i++) {
    var temp = Array();
    for (j = 0; j < dados[1].value - 1; j ++) {
      temp.push(Math.floor((Math.random() * (dados[1].value)) + 0));
      }
    desafios.push(temp);
    }

  // Agora, é gerado o HTML da atividade:
  var elemento = "<center><table>";

  // Primeiro: apresentando os valores e seus desenhos:
  elemento += "<tr class='parcelas'><td><div>";
  for (i = 0; i < dados[1].value; i++) {
    elemento += "<img width='100px' src='img/" + desenhos[i] + ".png'> = " + parcelas[i] + "";
    }
  elemento += "</div></td></tr>";

  // Segundo: apresentando os desafios:
  for (i = 0; i < dados[2].value; i++) {
    elemento += "<tr class='desafios'><td><div>";

    var d = desafios[i];
    for (j = 0; j < dados[1].value - 1; j++) {
      elemento += "<img width='100px' src='img/" 
                + desenhos[d[j]] + ".png'> ";
      if (j == dados[1].value - 2) continue;
      var op = dados[0].value;
      switch(op) {
        case "ADI": elemento += " + "; break;
        case "SUB": elemento += " - "; break;
        case "MUL": elemento += " x "; break;
        case "DIV": elemento += " / "; break;
        }
      }
    elemento += " = <input type=text size=2 id='resposta_" + i + "' /></div></td></tr>";
    }

  elemento += "<tr><td align='center'>" + criarBotao("submeter") + "</td></tr>";

  elemento += "</table>";
  //$(".resolucao").append(elemento);
  var item_res = document.getElementById("aluno"); // div "aluno"
  //var item_res = document.getElementsByClassName("resolucao"); // div "resolucao"
  item_res.style="display: block;"; // sobrescrever estido "display: none;"

  item_res.innerHTML = elemento;
  console.log("iarithmetic-functions.js: " + item_res);  // elemento
  } // organizaAtividadeSemResolucao(dados)


// Quando o aluno já tiver submetido a resposta, este método é chamado para apresentar
// a resolução enviada, tanto para o estudante quanto para o professor
function apresentaRespostas(dados) {
  t_respostas = dados[0].respostas;
  t_operacao = dados[1].operacao;
  t_parcelas = dados[2].parcelas;
  t_desenhos = dados[3].desenhos;
  t_desafios = dados[4].desafios;


  // Agora, é gerado o HTML da atividade:
  var elemento = "<center><table>";

  // Primeiro: apresentando os valores e seus desenhos:
  elemento += "<tr class='parcelas'><td><div>";
  for (i = 0; i < t_parcelas.length; i++) {
    elemento += "<img width='100px' src='img/" + t_desenhos[i] + ".png'> = " + t_parcelas[i] + "";
    }
  elemento += "</div></td></tr>";


  // Segundo: apresentando os desafios:
  for (i = 0; i < t_desafios.length; i++) {
    elemento += "<tr class='desafios'><td><div>";

    var d = t_desafios[i];
    for (j = 0; j < t_parcelas.length - 1; j++) {
      elemento += "<img width='100px' src='img/" + t_desenhos[d[j]] + ".png'> ";
      if (j == t_parcelas.length - 2) continue;

      switch(t_operacao) {
        case "ADI": elemento += " + "; break;
        case "SUB": elemento += " - "; break;
        case "MUL": elemento += " x "; break;
        case "DIV": elemento += " / "; break;
      }
    }
    elemento += " = <input type=text size=2 id='resposta_"+i+"' value='"+t_respostas[i]+"' disabled='true' /></div></td></tr>";
  }
   
  elemento += "</table>"; 
  $(".resolucao").append(elemento);

}
