/// Tutorial iMA
/// LInE https://www.usp.br/line/
/// iMática http://www.matematica.br

// Função para ler parâmetros informados pelo iTarefa via URL
// Apesar de não ser obrigatório, será muito útil para capturar os parâmetros
function getParameterByName (name) {
  var match = RegExp('[?&]' + name + '=([^&]*)').exec(window.location.search);
  return match ? decodeURIComponent(match[1].replace(/\+/g, ' ')) : null;
  }

// Criando um array com os parâmetros informados pelo iTarefa
// Observe que para cada parâmetro, é realizada a chamada do método getParameterByName, implementado acima
var iLMparameters = {
    iLM_PARAM_ServerToGetAnswerURL: getParameterByName("iLM_PARAM_ServerToGetAnswerURL"),
    iLM_PARAM_SendAnswer: getParameterByName("iLM_PARAM_SendAnswer"),
    iLM_PARAM_AssignmentURL: getParameterByName("iLM_PARAM_AssignmentURL"),
    iLM_PARAM_Assignment: getParameterByName("iLM_PARAM_Assignment"),
    lang: getParameterByName("lang")
    };



// JavaScript puro para substituir JQuery $('.<nomeClasse>').css("<estilo>","<valor>");
function setClassName (nomeClasse, estilo, valor) {
  var divResolucao = document.getElementsByClassName(nomeClasse); // pegar todos os elementos da classe 'nomeClasse'
  var totalE = divResolucao.length;
  for (i=0; i<totalE; i++)
     divResolucao[i].style.cssText = "display: block;";
  }
// JavaScript puro para substituir JQuery $('.<nomeClasse>').css("<estilo>","<valor>");
function getClassName (nomeClasse) {
  // var form1 = document.getElementsByName(nomeClasse); // pegar todos os elementos da classe 'nomeClasse'
  var form1 = document.querySelector('form');
  var elementos = form1.elements;
  var tam = elementos.length;
  var aux, vet = [];
  var str = "[";
  for (i = 0; i < tam; i++) {
    aux = elementos[i]; // deal with inputs[index] element.
    if (aux.name!="") // evita campo "submit"
      str += "{" + aux.name + "=" + aux.value + "}";
    }
  str += "]";
  console.log("getClassName: nomeClasse=" + nomeClasse + ", tam=" + tam + ", str=" + str);
  return str;
  }


// No prototipo: funcao em "index.html" associada ao botao de submissao
function submitContent () {
  var content = getAnswer();
  console.log(content);
  alert(content);
  }

// Função chamada pelo iTarefa quando o professor finaliza a criação da atividade
// ou quando o aluno finaliza a resolução do exercício
// O retorno é um JSON com os dados do exercício ou da resolução
// Esse retorno será armazenado no banco de dados do Moodle, pelo iTarefa
function getAnswer () {
  // Se o parâmetro "iLM_PARAM_SendAnswer" for false,
  // então trata-se de resolução de atividade
  if (iLMparameters.iLM_PARAM_SendAnswer == 'false') {
    // Montar o retorno da resposta do aluno
    var respostas = Array();
    var resposta = getClassName("resposta", "form");
    for (j = 0; j < desafios.length; j++) {
      // respostas.push(parseInt($("#resposta_" + j).val())); // versão com JQuery
      respostas.push(parseInt(resposta[j])); // versão JavaScript puro
      }
    return '[{"respostas": ' + JSON.stringify(respostas) + '}, {"operacao": "' + operacao + '"}, {"parcelas": ' + JSON.stringify(parcelas) + '}, {"desenhos": ' + JSON.stringify(desenhos) + ' }, '
           + '{"desafios": ' + JSON.stringify(desafios) + '}]';
  } else {
    // return JSON.stringify($('form[name="elaborar"]').serializeArray()); // Versão com JQuery
    // Verão JavaScript pura
    resposta = getClassName("elaborar", "form");
    console.log("getAnswer: " + resposta);
    return resposta; // minha funcao para definir estilo "block" para (todos elementos da) classe "resolucao"
    }
  }

// Função chamada pelo iTarefa para receber a nota do aluno na atividade
// O retorno é um valor entre 0.0 e 1.0
function getEvaluation () {
  if (iLMparameters.iLM_PARAM_SendAnswer == 'false') {
    // Calcula a nota do aluno:

    // Como a nota vai de 0 a 1, calculamos um valor unitário para cada acerto:
    var valor_cada_acerto = 1 / desafios.length;

    // Agora, verificamos o total de acertos do aluno:
    var acertos = 0;
    for (i = 0; i < desafios.length; i++) {
      var temp = parcelas[desafios[i][0]];
      for (j = 1; j < desafios[i].length; j++) {
        switch(operacao) {
          case "ADI": temp += parcelas[desafios[i][j]]; break;
          case "SUB": temp -= parcelas[desafios[i][j]]; break;
          case "MUL": temp *= parcelas[desafios[i][j]]; break;
          case "DIV": temp /= parcelas[desafios[i][j]]; break;
          }
        }
      var resposta = parseInt($("#resposta_" + i).val().trim());
      if (resposta == temp) {
        acertos ++;
        }
      }
    // Cálculo da nota: o produto do valor de cada desafio pelo número de acertos:
    var nota = valor_cada_acerto * acertos;
    // A chamada do método abaixo é obrigatória!
    // Observe que a chamada parte do iLM para o iTarefa
    parent.getEvaluationCallback(nota);
    }
  }


// Função para que o iMA leia os dados da atividade fornecidos pelo iTarefa
function getiLMContent () {
  // O parâmetro "iLM_PARAM_Assignment" fornece o URL do endereço que deve ser
  // requisitado via JavaScript para a captura dos dados da atividade
  var pagina = iLMparameters.iLM_PARAM_Assignment;
  var txtFile;
  var txtContent = ""; // evitar erro se conteúdo do iMA vazio
  var data = -1;
  if (iLMparameters.iLM_PARAM_Assignment == null) {
    console.log("integration-functions.js: getiLMContent(): NAO existe arquivo do iMA para ser carregado (iLMparameters.iLM_PARAM_Assigment)");
    return;
    }
  if (iLMparameters.iLM_PARAM_TeacherAutoEval != null) {
    try {
      parent.getAutoEvalOriginalData(); // funcao definida pelo iTarefa que devolve o conteudo original do exercicio atual
    } catch (Error) {
      console.log("integration-functions.js: getiLMContent(): erro ao tentar executar funcao 'getAutoEvalOriginalData()'");
      } // se nao esta' em re-avaliacao => NAO esta' definida 'parent.getAutoEvalOriginalData()'
    // teacherAutoEval(data); // Se o iMA tiver um avaliador em lote (util para evitar trapacas de "alunos espertos")
    console.log("integration-functions.js: getiLMContent(): final (apos ler arquivo IHN)");
    return;
    }
  txtFile = new XMLHttpRequest(); // preparar coneccao HTTP para requisitar um arquivo IHN
  txtFile.open("GET", pagina, true); // true=>asincrono - mas ambos estao resultando (arq. IHN nao passar teste XML...): XML Parsing
  txtFile.send(); // so' pode fechar apos 3o passo
  txtFile.responseType="text"; // Evita advertencia: XML Parsing Error: syntax error
  txtFile.onreadystatechange = function () {
    if (txtFile.readyState === 4) { // Makes sure the document is ready to parse.
      if (txtFile.status === 200) { // Makes sure the file exists.
        // 3o passo: por ultimo chega aqui!
        txtContent = txtFile.responseText;
        // processar conteudo de atividade iMA
	organizaAtividade(txtContent);
        }
      }
    }
  // Uma vez que os dados foram recebidos, o método "organizaAtividade" é chamado.
  // Observe que esse método faz parte do arquivo js/iarithmetic-functions.js
  organizaAtividade(txtContent);
  console.log("integration-functions.js: getiLMContent(): final");
  /*
  $.get(iLMparameters.iLM_PARAM_Assignment, function (d) {
    // Uma vez que os dados foram recebidos, o método "organizaAtividade" é chamado.
    // Observe que esse método faz parte do arquivo js/iarithmetic-functions.js
    organizaAtividade(d);
  });*/
  }


function loadiMA () {
  // Se iLM_PARAM_SendAnswer for false, então trata-se de resolução de atividade,
  // portanto, a "DIV" de resolução é liberada
  if (iLMparameters.iLM_PARAM_SendAnswer == 'false') {
    // $('.resolucao').css("display","block"); // index.html: <div class="resolucao" style="display: none;">
    // Versao sem JQuery:
    setClassName("resolucao", "display", "block"); // minha funcao para definir estilo "block" para (todos elementos da) classe "resolucao"

    //D alert("integration-functions.js: divResolucao=" + divResolucao);
    //D console.log("integration-functions.js: " + getAllTagClasses());
    getiLMContent();
    //D console.log("integration-functions.js: ready(): iLM_PARAM_SendAnswer=false");
  } else {
    // Caso não esteja em modo de resolução de atividade, a visualização no momento
    // é para a elaboração de atividade:
    // $('.elaboracao').css("display","block");
    setClassName("elaboracao", "display", "block"); // minha funcao para definir estilo "block" para (todos elementos da) classe "resolucao"
    //D console.log("integration-functions.js: ready(): iLM_PARAM_SendAnswer=true");
    }
  }



// Adicionamos a diretiva .ready(), para que quando a página HTML estiver carregada,
// seja verificado qual a visualização deve ser apresentada: se a área de construção
// de atividade ou de resolução. E no caso de ser resolução, os dados da atividade
// precisam ser consultados, pelo método implementado acima, o getiLMContent()
/*
$(document).ready(function() {
  loadiMA();
  });
*/

function getAllTagClasses () {
  var str = "";
  var allClasses = [];
  var allElements = document.querySelectorAll('*');
  for (var i = 0; i < allElements.length; i++) {
  if (allElements[i].hasAttribute("class")) {
    var classes = allElements[i].className.toString().split(/\s+/);
    for (var j = 0; j < classes.length; j++) {
      var cls = classes[j];
	if (cls && allClasses.indexOf(cls) === -1) {
          allClasses.push(cls);
          str += cls + ", ";
          }
	}
      }
    }
  return str;
  }

//console.log(allClasses);